import { AllowedComponentProps, ComponentCustomProps, VNodeProps, VNode, App } from 'vue';
import { FindChunksArgs, Chunk } from 'highlight-words-core';

interface VueHighlighterProps {
    activeClassName?: string;
    activeIndex?: number;
    activeStyle?: Partial<CSSStyleDeclaration>;
    custom?: boolean;
    highlightClassName?: string;
    highlightStyle?: Partial<CSSStyleDeclaration>;
    onWordClick?: (textChunk: TextChunk) => void;
    onWordHover?: (textChunk: TextChunk) => void;
    autoEscape?: boolean;
    caseSensitive?: boolean;
    findChunks?: (args: FindChunksArgs) => Chunk[];
    sanitize?: (text: string) => string;
    searchWords: string[];
    textToHighlight: string;
}
interface TextChunk {
    chunk: Chunk;
    text: string;
    attrs?: {
        class: string;
        key: number;
        highlightIndex: number;
        style: Partial<CSSStyleDeclaration>;
    };
}
declare const VueHighlighter: new () => {
    $props: AllowedComponentProps & ComponentCustomProps & VNodeProps & VueHighlighterProps;
    $slots: {
        default: (arg: TextChunk[]) => VNode[];
    };
};

declare function install(app: App, options?: {
    name: string;
}): void;

export { type TextChunk, VueHighlighter, type VueHighlighterProps, VueHighlighter as default, install };
